<template>
  <div class="create-article no-wrap column" :class="{ 'q-py-lg': step != 4, 'q-pb-lg': step === 4 }">
    <div v-show="step === 1" class="create-article__step-1 no-wrap column col q-gutter-md">
      <h1 class="text-h1">Preview your story</h1>
      <q-input
        v-model="article.title"
        type="text"
        label="Title"
        outlined
        class="default-input"
        style="font-size: 18px"
        autogrow
      />
      <q-input
        v-model="article.description"
        type="text"
        label="Preview description"
        outlined
        class="default-input"
        autogrow
      />
      <q-select
        v-model="article.categories"
        multiple
        :options="categoriesList"
        use-chips
        stack-label
        label="Multiple selection"
        outlined
        dark
        class="default-input"
        option-value="slug"
        option-label="title"
        emit-value
        map-options
      />
      <div class="create-article__image__uploader col column">
        <q-uploader
          flat
          class="full-width col default-uploader"
          url="http://localhost:3000/upload"
          label="Uplad an image preview"
          accept=".jpg, image/*"
          dark
          text-color="dark"
          @rejected="onRejected"
          @added="addPreviewImg"
        >
          <template v-slot:header="scope">
            <div class="row no-wrap items-center q-pa-sm q-gutter-xs">
              <q-btn
                v-if="scope.uploadedFiles.length > 0"
                icon="done_all"
                @click="scope.removeUploadedFiles"
                round
                dense
                flat
              >
                <q-tooltip>Remove Uploaded Files</q-tooltip>
              </q-btn>
              <q-spinner v-if="scope.isUploading" class="q-uploader__spinner" />
              <div class="col">
                <div class="q-uploader__title">Upload your files</div>
                <div class="q-uploader__subtitle">{{ scope.uploadSizeLabel }} / {{ scope.uploadProgressLabel }}</div>
              </div>
              <q-btn v-if="scope.canAddFiles" type="a" icon="add_box" @click="scope.pickFiles" round dense flat>
                <q-uploader-add-trigger />
                <q-tooltip>Pick Files</q-tooltip>
              </q-btn>

              <!-- <q-btn
                v-if="scope.canUpload && scope"
                icon="cloud_upload"
                @click="scope.upload"
                round
                dense
                flat
              >
                <q-tooltip>Upload Files</q-tooltip>
              </q-btn> -->
              <q-btn
                v-if="scope.queuedFiles[0]"
                color="dark"
                size="16px"
                flat
                dense
                round
                icon="delete"
                @click="scope.removeFile(scope.queuedFiles[0])"
              >
                <q-tooltip>Remove Queued Files</q-tooltip>
              </q-btn>
              <q-btn v-if="scope.isUploading" icon="clear" @click="scope.abort" round dense flat>
                <q-tooltip>Abort Upload</q-tooltip>
              </q-btn>
            </div>
          </template>
          <template v-slot:list="scope">
            <q-item class="col column">
              <q-item-section
                rounded
                v-if="scope.files[0]"
                class="bg-primary text-dark flex flex-center relative-position"
                style="border-radius: 12px"
              >
                <q-img class="rounded-borders" style="max-width: 100%" :src="scope.files[0].__img.src" alt="" />
              </q-item-section>
            </q-item>
          </template>
        </q-uploader>
      </div>
    </div>
    <div v-show="step === 2" class="create-article__step-3 no-wrap column col q-gutter-sm">
      <h1 class="text-h1">Is it looks cool?</h1>
      <Article
        :imgPreview="article.previewImg"
        :title="article.title"
        :categories="article.categories"
        :description="article.description"
      />
    </div>
    <div v-if="step === 3" class="create-article__step-3 create-article__editor column no-wrap col q-gutter-md">
      <h1 class="text-h1">Write your story</h1>
      <q-editor
        dark
        class=""
        toolbar-text-color="white"
        toolbar-bg="dark"
        v-model="article.content"
        :toolbar="[
          [
            {
              label: $q.lang.editor.align,
              icon: $q.iconSet.editor.align,
              fixedLabel: true,
              list: 'only-icons',
              options: ['left', 'center', 'right', 'justify'],
            },
          ],
          ['bold', 'italic', 'strike', 'underline', 'subscript', 'superscript'],
          ['token', 'hr', 'link', 'custom_btn'],
          ['print', 'fullscreen'],
          [
            {
              label: $q.lang.editor.formatting,
              icon: $q.iconSet.editor.formatting,
              list: 'no-icons',
              options: ['p', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'code'],
            },
            {
              label: $q.lang.editor.fontSize,
              icon: $q.iconSet.editor.fontSize,
              fixedLabel: true,
              fixedIcon: true,
              list: 'no-icons',
              options: ['size-1', 'size-2', 'size-3', 'size-4', 'size-5', 'size-6', 'size-7'],
            },
            {
              label: $q.lang.editor.defaultFont,
              icon: $q.iconSet.editor.font,
              fixedIcon: true,
              list: 'no-icons',
              options: [
                'default_font',
                'arial',
                'arial_black',
                'comic_sans',
                'courier_new',
                'impact',
                'lucida_grande',
                'times_new_roman',
                'verdana',
              ],
            },
            'removeFormat',
          ],
          ['quote', 'unordered', 'ordered', 'outdent', 'indent'],

          ['undo', 'redo'],
          ['viewsource'],
        ]"
        :fonts="{
          arial: 'Arial',
          arial_black: 'Arial Black',
          comic_sans: 'Comic Sans MS',
          courier_new: 'Courier New',
          impact: 'Impact',
          lucida_grande: 'Lucida Grande',
          times_new_roman: 'Times New Roman',
          verdana: 'Verdana',
        }"
      />
      <q-card dark flat bordered>
        <q-card-section class="create-article__story-realtime-preview" v-html="article.content" />
      </q-card>
    </div>

    <div v-if="step === 4" class="create-article__step-4 column no-wrap col" style="margin-top: 0px">
      <div class="create-article__preview-story preview-story column q-mb-xl">
        <ArticleFullPreview
          :article="{
            title: article.title,
            categories: article.categories,
            content: article.content,
            description: article.description,
            previewImg: article.previewImg,
          }"
          :user="{}"
        />
      </div>
    </div>

    <div class="create-article__navigation q-mt-md q-gutter-x-md justify-end row">
      <q-btn
        v-show="step > 1"
        unelevated
        color="primary"
        text-color="secondary"
        icon="arrow_back_ios"
        label="Back"
        @click="step -= 1"
      />
      <q-btn
        v-show="step != 4"
        unelevated
        color="primary"
        text-color="secondary"
        icon="arrow_forward_ios"
        :label="getForwarBtnLabel()"
        @click="step += 1"
      />
      <q-btn
        v-show="step === 4"
        unelevated
        color="primary"
        text-color="secondary"
        icon="arrow_forward_ios"
        :label="getForwarBtnLabel()"
        @click="uploadArticle()"
      />
    </div>
  </div>
</template>

<script setup>
import { ref, reactive, computed } from "vue";
import Article from "../components/Article";
import ArticleFullPreview from "../components/ArticleFullPreview.vue";
import { uploadArticle as _uploadArticle } from "../services/articleService";
import { useStore } from "vuex";
import { useRouter } from "vue-router";

const store = useStore();
const router = useRouter();
const userData = computed(() => store.getters["userModule/userData"]);
const categoriesList = require("../services/categories.json").categories;

const step = ref(1);
function getForwarBtnLabel() {
  if (step.value === 1) {
    return "forward to preview";
  }
  if (step.value === 2) {
    return "forward";
  }
  if (step.value === 3) {
    return "preview result";
  }
  if (step.value === 4) {
    return "upload writings";
  }
}

const article = reactive({
  title: "The Witcher 3: Wild Hunt's",
  img: null,
  previewImg: null,
  description: "",
  categories: [],
  content: ``,
});

function addPreviewImg(files) {
  article.img = files[0];
  article.previewImg = URL.createObjectURL(files[0]);
}
function onRejected() {
  return;
}

async function uploadArticle() {
  const result = await _uploadArticle(
    userData.value.id,
    article.title,
    article.title,
    article.categories,
    article.content,
    article.description,
    article.img
  );
  if (!result) {
    return;
  }
  //show Success dialog await $refs.successDialog.Open()
  //await close => route to index
  router.push({ name: "Index" });
}
</script>

<style lang="scss" scoped>
.create-article {
  max-width: 100%;
  padding-left: 15.27vw;
  padding-right: 15.27vw;
  ::v-deep .q-editor {
    &__toolbars-container {
      color: red;
      overflow: auto;
    }
    &__content {
      img {
        width: 100% !important;
        height: auto !important;
        padding-top: 8px !important;
        padding-bottom: 8px !important;
      }
    }
  }
  ::v-deep &__story-realtime-preview {
    img {
      width: 100% !important;
      height: auto !important;
      padding-top: 8px !important;
      padding-bottom: 8px !important;
    }
  }
}
</style>
